cap prog drop areggrp

* iterated 2-step GLS for grouped data recommended by Decker (1990)
* written by Treb Allen on December 13, 2009

prog define areggrp
	version 10
	syntax varlist [if] [in], weight(varname) tol(real) *

tempvar temp_newweight temp_resid temp_resid_sqrd temp_inv_weight

quietly {

gen `temp_newweight'=`weight'

local diff = 1
local c_old = 0
local b_old = 0

gen `temp_inv_weight' = 1 / `weight'

while `diff'>`tol' {

cap drop `temp_resid_sqrd' `temp_resid'

areg `varlist' `if' `in' [aweight=`temp_newweight'], `options'
predict `temp_resid' `if' `in', residuals
gen `temp_resid_sqrd' = `temp_resid'^2

reg `temp_resid_sqrd' `temp_inv_weight' if e(sample)
drop `temp_newweight'
gen `temp_newweight' = 1 / (_b[_cons]^2 +_b[`temp_inv_weight']^2/`weight')

local diff = (_b[_cons]-`c_old')^2 + (_b[`temp_inv_weight'] - `b_old')^2
local c_old = _b[_cons]
local b_old = _b[`temp_inv_weight']

}

}

display as res "Iterated 2-Step GLS for Grouped Data a la Decker (1990)"
areg `varlist' `if' `in' [aweight=`temp_newweight'], `options'

end
